#include "eeprom.h"

void eeprom_erreur()
{
	message_erreur("Une erreur est survenue lors de la communication avec l'eeprom",0);
	Power_off();
}

void envoie_I2C(u_int16_t donnee)
{
//scl et sda sont cens etre  0
	int b,i;
	i=0;

	while (i<8)
	{
		b=donnee&128;

//			printf("-	Mise  1 de l'horloge\n");
		clock_a_0();
//			printf("-	Mise  %d du bit %d\n",b,i);
		if (b) 	data_a_1();
			else	data_a_0();
		attente(1);
//			printf("-	Mise  0 de l'horloge\n");
		clock_a_1();
		attente(1);
		i++;
		donnee=(donnee&127)*2; // -> corespond  une rotation vers la gauche
	}

}
unsigned char recoit_I2C()
{
	u_int16_t donnee;
	int b,i;
	i=0;
	donnee=0;
	while(i<8)
	{
//			printf("-	Mise  1 de l'horloge\n");
		donnee=donnee*2;
		clock_a_0();
  		attente(1);
  		data_a_1();
  		attente(1);
//			printf("-	reception de %d pour le bit %d\n",b,i);
		clock_a_1();

		attente(1);
		b=get_b_data();
		i++;
		donnee+=b;	//on commence du 8me bit
	}
	return donnee;

}
void I2C_bit_start()
{
	clock_a_0();
	attente(1);
	data_a_1();
	attente(1);
	clock_a_1();
	attente(1);
	data_a_0();
	attente(1);
	clock_a_0();
	attente(1);
}
void I2C_bit_stop()
{
	clock_a_0();
	attente(1);
	data_a_0();
	attente(1);
	clock_a_1();
	attente(1);
	data_a_1();
	attente(1);
}
int Ack_I2C()
{
	clock_a_0();
	attente(1);
	data_a_1();
	attente(1);
	clock_a_1();
	attente(1);
	return get_b_data();
}

unsigned char * Lire_EEPROM_I2C(unsigned char * buffer)
{
	int duree;
	int adr_eeprom;
	int for_progress_bar=tab_pic[pic_select]->memoire_D;
	init_port();
	Power_on();

	adr_eeprom=le_data_deb;
	while((adr_eeprom<tab_pic[pic_select]->memoire_D)&&(adr_eeprom<=le_data_fin))
	{
		duree=0;
		if (tab_pic[pic_select]->algo!=-2)
		{
			do {
				I2C_bit_start();
				envoie_I2C(160+((adr_eeprom/128)&14));
				duree++;
			}while (Ack_I2C() && duree<10000);
			if (duree==10000)
			{
				printf("Un problme avec l'ack pour l'addresse1\n");
				eeprom_erreur();
				return buffer;
			}
		}
		else
		{
			do {
				I2C_bit_stop();
				I2C_bit_start();
				envoie_I2C(160);
				duree++;
			}while (Ack_I2C() && duree<10000);
			if (duree==10000)
			{
				printf("Un problme avec l'ack pour l'addresse1\n");
				eeprom_erreur();
				return buffer;
			}

			// envoie_I2C((adr_eeprom&(65535-255));
			envoie_I2C(adr_eeprom>>8);
			if(Ack_I2C())
			{
				printf("Un problme avec l'ack pour l'addresse2\n");
				eeprom_erreur();
				return buffer;
			}
		}
		envoie_I2C(adr_eeprom&255);
		if(Ack_I2C())
		{
			printf("Un problme avec l'ack pour l'addresse2\n");
			eeprom_erreur();
			return buffer;
		}

		I2C_bit_start();
		if (tab_pic[pic_select]->algo!=-2) envoie_I2C(160+((adr_eeprom/128)|1));
			else  envoie_I2C(161);
		if(Ack_I2C())
		{
			printf("Un problme avec l'ack pour l'addresse3\n");
			eeprom_erreur();
			return buffer;
		}
		buffer[adr_eeprom]=recoit_I2C();
		adr_eeprom++;
		if (adr_eeprom%(for_progress_bar/NB_INCREMENT_BAR+1)==0)
			gestion_bar(adr_eeprom,for_progress_bar,3);

		clock_a_0();
		attente(1);
		data_a_1();
		attente(1);

		clock_a_1();
		attente(1);
		I2C_bit_stop();
	}
	Power_off();
	return buffer;
}

int Charge_EEPROM_I2C(unsigned char * buffer)
{

	int adr_eeprom;
	int duree;
	int for_progress_bar=tab_pic[pic_select]->memoire_D;
	init_port();
	Power_on();

	adr_eeprom=le_data_deb;
	while((adr_eeprom<tab_pic[pic_select]->memoire_D)&&(adr_eeprom<=le_data_fin))
	{
		if (tab_pic[pic_select]->algo!=-2)
		{
			duree=0;
			do {
				I2C_bit_start();
				envoie_I2C(160+((adr_eeprom/128)&14));
				duree++;
			}while (Ack_I2C() && duree<10000);
			if (duree==10000)
			{
				printf("Un problme avec l'ack pour l'addresse1\n");
				eeprom_erreur();
				return -1;
			}
		}
		else
		{
			duree=0;
			do {
				I2C_bit_start();
				envoie_I2C(160);
				duree++;
			}while (Ack_I2C() && duree<10000);
			if (duree==10000)
			{
				printf("Un problme avec l'ack pour l'addresse1\n");
				eeprom_erreur();
				return -1;
			}
			envoie_I2C(adr_eeprom>>8);
			if(Ack_I2C())
			{
				printf("Un problme avec l'ack pour l'addresse2\n");
				eeprom_erreur();
				return -1;
			}
		}

		envoie_I2C(adr_eeprom&255);
		if(Ack_I2C())
		{
			printf("Un problme avec l'ack pour l'addresse2\n");
			eeprom_erreur();
			return -1;
		}
		envoie_I2C(buffer[adr_eeprom]);
		if(Ack_I2C())
		{
			printf("Un problme avec l'ack pour les donnees\n");
			eeprom_erreur();
			return -1;
		}
		I2C_bit_stop();

	//	printf ("Donnee envoyee: %d\n",donnee);
		adr_eeprom++;
		if (adr_eeprom%(for_progress_bar/NB_INCREMENT_BAR+1)==0)
			gestion_bar(adr_eeprom,for_progress_bar,2);

	}
	attente(10000);
	Power_off();
	return 0;
}

void envoie_serie(u_int16_t donnee,int nbit)
{
//scl et sda sont cens etre  0
	int b,i;
	i=0;

	while (i<nbit)
	{
		b=donnee&(1<<(nbit-1));
//			printf("-	Mise  1 de l'horloge\n");
		clock_a_0();
//			printf("-	Mise  %d du bit %d\n",b,i);
		if (b) 	data_93_a_1();
			else	data_93_a_0();
		attente(1);
//			printf("-	Mise  0 de l'horloge\n");
		clock_a_1();
		attente(1);
		i++;
		donnee=(donnee&((1<<(nbit-1))-1))*2; // -> corespond  une rotation vers la gauche
	}

}
unsigned char recoit_serie()
{
	u_int16_t donnee;
	int b,i;
	i=0;
	donnee=0;
	data_a_1();
	while(i<8)
	{
//			printf("-	Mise  1 de l'horloge\n");
		donnee=donnee*2;
		clock_a_0();
  		attente(1);
		b=get_b_data();
//			printf("-	reception de %d pour le bit %d\n",b,i);
		clock_a_1();
		attente(1);
		i++;
		donnee+=b;	//on commence du 8me bit
	}
	return donnee;

}

void enable_write_serie(int num_bit)
{
	data_a_1();
	s_a_0();
	clock_a_0();
	attente(1);
	data_93_a_1();
	s_a_1();
	attente(1);
	clock_a_1();
	attente(1);

	envoie_serie(3,4);
	envoie_serie(0,num_bit-2);

	data_93_a_0();
	attente(1);
	s_a_0();
	attente(1);
}
void disable_write_serie(int num_bit)
{
	data_a_1();
	s_a_1();
	attente(1);
	clock_a_0();
	attente(1);
	data_93_a_1();
	attente(1);
	clock_a_1();
	attente(1);
	envoie_serie(0,4);
	envoie_serie(0,num_bit-2);
	s_a_0();
	attente(1);
}

unsigned char* Lire_EEPROM_serie(unsigned char * buffer,int num_bit)
{
	int adresse;
	int for_progress_bar=tab_pic[pic_select]->memoire_D;
	init_port();
	Power_on();

	adresse=le_data_deb;
	while((adresse<tab_pic[pic_select]->memoire_D)&&(adresse<=le_data_fin))
	{
		data_a_1();
		s_a_0();
		clock_a_0();
		attente(1);
		data_93_a_1();
		s_a_1();
		attente(1);
		clock_a_1();
		attente(1);

		envoie_serie(2,2);
		envoie_serie(adresse,num_bit);

		data_93_a_0();
		clock_a_0();
		attente(1);
		clock_a_1();
		attente(1);
		buffer[adresse]=recoit_serie();
		s_a_0();
		attente(1);
		clock_a_0();
		attente(1);
		clock_a_1();
		attente(1);
		adresse++;
		if (adresse%(for_progress_bar/NB_INCREMENT_BAR+1)==0)
			gestion_bar(adresse,for_progress_bar,3);

	}
	Power_off();
	return buffer;
}
int Charge_EEPROM_serie(unsigned char * buffer,int num_bit)
{
	int i;
	int adresse;
	int for_progress_bar=tab_pic[pic_select]->memoire_D;
	init_port();
	Power_on();
	enable_write_serie(num_bit);
	adresse=le_data_deb;
	while((adresse<tab_pic[pic_select]->memoire_D)&&(adresse<=le_data_fin))
	{
		data_a_1();
		s_a_0();
		clock_a_0();
		attente(1);
		data_93_a_1();
		s_a_1();
		attente(1);
		clock_a_1();
		attente(1);

		envoie_serie(1,2);
		envoie_serie(adresse,num_bit);
		envoie_serie(buffer[adresse],8);
		clock_a_0();
		data_93_a_0();
		attente(1);
		s_a_0();
		attente(1);
		s_a_1();
		attente(1);
		clock_a_1();
		attente(1);
		i=0;
		while (!get_b_data() && i<10000)
		{
			clock_a_0();
			attente(1);
			clock_a_1();
			attente(1);
			i++;
		}
		if (i==10000)
		{
			printf("erreur : serie toujours busy\n");
			eeprom_erreur();
			return -1;
		}

		s_a_0();
		attente(1);
		clock_a_0();
		attente(1);
		clock_a_1();
		attente(1);

		adresse++;
		if (adresse%(for_progress_bar/NB_INCREMENT_BAR+1)==0)
			gestion_bar(adresse,for_progress_bar,2);

	}
	disable_write_serie(num_bit);
	Power_off();
	return 0;
}

//-----------------------------------------------------
unsigned char* Lire_EEPROM_SPI(unsigned char * buffer,int num_bit)
{
	int adresse;
	int for_progress_bar=tab_pic[pic_select]->memoire_D;

	init_port();
	Power_on();
	attente(1);
	s_a_1();
	attente(1);
	//adresse=0;
	//while(adresse<tab_pic[pic_select]->memoire_D)
	adresse=le_data_deb;
	while((adresse<tab_pic[pic_select]->memoire_D)&&(adresse<=le_data_fin))
	{
		clock_a_0();
		attente(1);
		data_a_1();
		s_a_0();
		data_93_a_0();
		attente(1);
		clock_a_1();
		attente(1);


		envoie_serie(0,3); //on en a deja envoy un (d'aprs xavier)
		envoie_serie((adresse&256)*(num_bit==9),1);
		envoie_serie(3,3);
		envoie_serie(adresse,num_bit&24);

		//data_93_a_0(); //inutile
		buffer[adresse]=recoit_serie();
		//printf("donnee : %X\n",buffer[adresse]);
		clock_a_0();
		attente(1);
		s_a_1();
		attente(1);
		adresse++;
		if (adresse%(for_progress_bar/NB_INCREMENT_BAR+1)==0)
			gestion_bar(adresse,for_progress_bar,3);

	}
	Power_off();
	return buffer;
}
void enable_write_SPI()
{
	s_a_1();
	clock_a_0();
	attente(1);
	data_a_1();
	s_a_0();
	data_93_a_0();
	attente(1);
	clock_a_1();
	attente(1);
	envoie_serie(6,7); //on en a deja envoy un (d'aprs xavier)
	clock_a_0();
	attente(1);
	s_a_1();
	attente(1);
}

void disable_protection_SPI()
{
	s_a_1();
	clock_a_0();
	attente(1);
	data_a_1();
	s_a_0();
	data_93_a_0();
	attente(1);
	clock_a_1();
	attente(1);
	envoie_serie(1,7); //on en a deja envoy un (d'aprs xavier)
	envoie_serie(0,8); //bourrin
	clock_a_0();
	attente(1);
	s_a_1();
	attente(1);
}

int Charge_EEPROM_SPI(unsigned char * buffer,int num_bit)
{

	int adresse;
	int for_progress_bar=tab_pic[pic_select]->memoire_D;
	init_port();
	Power_on();

	attente(1);
	disable_protection_SPI();
	adresse=le_data_deb;
	while((adresse<tab_pic[pic_select]->memoire_D)&&(adresse<=le_data_fin))
	{
		enable_write_SPI();

		clock_a_0();
		attente(1);
		data_a_1();
		s_a_0();
		data_93_a_0();
		attente(1);
		clock_a_1();
		attente(1);

		envoie_serie(0,3); //on en a deja envoy un (d'aprs xavier)
		envoie_serie((adresse&256)*(num_bit==9),1);
		envoie_serie(2,3);
		envoie_serie(adresse,num_bit&24);
		envoie_serie(buffer[adresse],8);
		clock_a_0();
		attente(1);
		s_a_1();
		attente(10000);//10 ms

		adresse++;
		if (adresse%(for_progress_bar/NB_INCREMENT_BAR+1)==0)
			gestion_bar(adresse,for_progress_bar,2);

	}

	Power_off();
	return 0;
}
